// C Source File
// Created 01.05.2009; 10:59:27

// sorry I dont use German words to annoy you - its just easier for myself


// NOTE: I am a program beginner so the code is not always the best (but its my first REAL game)


#include <tigcclib.h>
// Problems:																				SPECIAL-ATTACKS (einfach runnen)
#define HEIGHT 8
#define ARROW_ROW 0xFFFE

unsigned char player[] = {0x7e,0x81,0xa5,0x99,0xc3,0x81,0xa5,0x7e};
unsigned char gegner[] = {0x24,0x5a,0xa5,0x99,0xc3,0x99,0xa5,0x7e};
unsigned char blast[] = {0xf7,0xff,0xdf,0xff,0xfd,0x7f,0xef,0xff};
unsigned char blanc[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
unsigned char full[] = {0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff};
unsigned short seite[] = {0x0180,0x0660,0x0990,0x1668,0x0990,0x0660,0x0180,0x0000};
/* unsigned char player[] = {
	0b01111110	/		//	0x7e
	0b10000001	/		//	0x81
	0b10100101	/		//	0xa5
	0b10011001	/		//	0x99
	0b11000011	/		//	0xc3
	0b10000001	/		//	0x81
	0b10100101	/		//	0xa5
	0b01111110			//	0x7e
};	// Binarys for 'player'	*/

typedef struct {	//	types for the player
	unsigned long int health:7,x:8,y:7,mp:7;	//3 bits free
} PLAYER;
enum {left=1,right,up,down};








inline void show(PLAYER p1,PLAYER enemy) // show player and sides
{
	unsigned char x,y;
	clrscr();
	for (x=0;x<LCD_WIDTH;x+=16) {
		Sprite16(x,0,HEIGHT,seite,LCD_MEM,SPRT_OR);
	}
	for (y=0;y<LCD_HEIGHT-8;y+=8) {
		Sprite16(0,y,HEIGHT,seite,LCD_MEM,SPRT_OR);
		Sprite16(LCD_WIDTH-16,y,HEIGHT,seite,LCD_MEM,SPRT_OR);
	}
	DrawLine(14,LCD_HEIGHT-8,LCD_WIDTH-15,LCD_HEIGHT-8,A_NORMAL);	// bottom-line
	DrawLine(14,7,LCD_WIDTH-15,7,A_NORMAL);												// top-line
	DrawLine(14,7,14,LCD_HEIGHT-9,A_NORMAL);											// left line
	DrawLine(LCD_WIDTH-15,7,LCD_WIDTH-15,LCD_HEIGHT-8,A_NORMAL);	// right line
	
	
	
	
	Sprite8(p1.x,p1.y,HEIGHT,player,LCD_MEM,SPRT_OR);
	Sprite8(enemy.x,enemy.y,HEIGHT,gegner,LCD_MEM,SPRT_OR);
	
}

void delay(int delayNum) // slow down the program
{
	int num,randNum;
	for (num=0;num<=delayNum;num++) {
		if (_rowread(0xFEFF)&0x0040) break;	// ESC_KEY
		randNum = rand() % num;
	}
}

int direct(void) // select the direction for the next special-attack
{
	char direction=0;
	unsigned char num;
	for (num=0;num<LCD_WIDTH;num+=8) Sprite8(num,LCD_HEIGHT-7,HEIGHT,blanc,LCD_MEM,SPRT_AND);
	
	FontSetSys(F_6x8);
	DrawStr(LCD_WIDTH/2-60,LCD_HEIGHT-7,"select the direction",A_NORMAL);
	while (!direction) {
		if (_rowread(ARROW_ROW)&0x0010) direction=left;		// Key left
		if (_rowread(ARROW_ROW)&0x0040) direction=right;
		if (_rowread(ARROW_ROW)&0x0020) direction=up;
		if (_rowread(ARROW_ROW)&0x0080) direction=down;
	}
	return direction;
}

int test(PLAYER player,char direction) // tests if player can move there
{
	int num;
	if (direction==left) {
		for (num=player.y;num<=player.y+7;num++) {
			if (GetPix(player.x-1,num)) return FALSE;		// if theres something standing in the way return false
		}
	}
	if (direction==right) {
		for (num=player.y;num<=player.y+7;num++) {
			if (GetPix(player.x+8,num)) return FALSE;
		}
	}
	if (direction==up) {
		for (num=player.x;num<=player.x+7;num++) {
			if (GetPix(num,player.y-1)) return FALSE;
		}
	}
	if (direction==down) {
		for (num=player.x;num<=player.x+7;num++) {
			if (GetPix(num,player.y+8)) return FALSE;
		}
	}
	// if theres nothing standing in front of the player whos moving, return true
	return TRUE;
}

inline void state(PLAYER p1,int pt,PLAYER enemy) // show all stats you may want to know
{
	char x;
	FontSetSys(F_6x8);
	for (x=0;x<LCD_WIDTH/8;x++) Sprite8(x*8,LCD_HEIGHT-7,HEIGHT,blanc,LCD_MEM,SPRT_AND);
	printf_xy(10,LCD_HEIGHT-7,"health:%d |mp:%d |pts:%d |e-health:%d",p1.health,p1.mp,pt,enemy.health);
	
}

int richtung(PLAYER enemy,PLAYER p1) // check where it would be best to go
{
	// I think there are better possibilitys to get the enemy move to the player but that works fine
	if (p1.x-enemy.x<0) {	// if player is on the left side of the cpu
		if (p1.y-enemy.y<0) {	//if player is on the upper side
			if (p1.x-enemy.x<p1.y-enemy.y) return left; else return up;
		} else { // if player is downside
			if (((p1.x-enemy.x)*-1)>p1.y-enemy.y) return left; else return down;
		}
		
	}
	if (p1.x-enemy.x>0) {	// if player is on the right side
		if (p1.y-enemy.y<0) {	// player on upper side
			if (p1.x-enemy.x>((p1.y-enemy.y)*-1)) return right; else return up;
		} else { // player is downside
			if (p1.x-enemy.x>p1.y-enemy.y) return right; else return down;
		}
		
		
	}
	// if player.x == enemy.x then make a test if the enemy shall move up or down
	if (p1.y-enemy.y<0) return up; else return down;
	
	
}

int s_explode(PLAYER player,PLAYER notPlayer,char row) // Animated small explosion
{
	unsigned char treffer=0,x,y,direction;
	unsigned char exp1[] = {
		0b00000000,
		0b00000000,
		0b00000000,
		0b00011000,
		0b00011000,
		0b00000000,
		0b00000000,
		0b00000000
	};
	unsigned char exp2[] = {
		0b00000000,
		0b00000000,
		0b00010100,
		0b01011000,
		0b00011010,
		0b00100100,
		0b00000000,
		0b00000000
	};
	unsigned char exp3[] = {
		0b00001000,
		0b10100010,
		0b00010100,
		0b01010000,
		0b10001010,
		0b00100100,
		0b00101010,
		0b10000000
	};
	unsigned char exp4[] = {
		0b00101000,
		0b10100010,
		0b00010100,
		0b01000001,
		0b10001010,
		0b10100101,
		0b00101010,
		0b10010100
	};
	unsigned char exp5[] = {
		0b00101000,
		0b10100010,
		0b00010100,
		0b01000001,
		0b10000010,
		0b10100101,
		0b00101010,
		0b01010100
	};
	unsigned char exp6[] = {
		0b00101000,
		0b10100010,
		0b00000100,
		0b10000001,
		0b00000010,
		0b10000001,
		0b01000010,
		0b10010100
	};
	
	if (!row) direction=direct(); else direction=row;
	
	if (direction==left) {
		Sprite8(player.x-8,player.y,HEIGHT,exp1,LCD_MEM,SPRT_XOR);
		delay(2000);
		Sprite8(player.x-8,player.y,HEIGHT,exp1,LCD_MEM,SPRT_XOR);
		Sprite8(player.x-8,player.y,HEIGHT,exp2,LCD_MEM,SPRT_XOR);
		delay(2000);
		Sprite8(player.x-8,player.y,HEIGHT,exp2,LCD_MEM,SPRT_XOR);
		Sprite8(player.x-8,player.y,HEIGHT,exp3,LCD_MEM,SPRT_XOR);
		delay(2000);
		Sprite8(player.x-8,player.y,HEIGHT,exp3,LCD_MEM,SPRT_XOR);
		Sprite8(player.x-8,player.y,HEIGHT,exp4,LCD_MEM,SPRT_XOR);
		delay(2000);
		Sprite8(player.x-8,player.y,HEIGHT,exp4,LCD_MEM,SPRT_XOR);
		Sprite8(player.x-8,player.y,HEIGHT,exp5,LCD_MEM,SPRT_XOR);
		delay(2000);
		Sprite8(player.x-8,player.y,HEIGHT,exp5,LCD_MEM,SPRT_XOR);
		Sprite8(player.x-8,player.y,HEIGHT,exp6,LCD_MEM,SPRT_XOR);
		delay(2000);
		Sprite8(player.x-8,player.y,HEIGHT,exp6,LCD_MEM,SPRT_XOR);
		for (x=player.x-8;x<=player.x;x++) {
			for (y=player.y;y<=player.y+8;y++) {
				if ((x>=notPlayer.x&&x<=notPlayer.x+8) && (y>=notPlayer.y&&y<=notPlayer.y+8)) treffer=1;
			}
		}
	} else 
	if (direction==right) {
		Sprite8(player.x+8,player.y,HEIGHT,exp1,LCD_MEM,SPRT_XOR);
		delay(2000);
		Sprite8(player.x+8,player.y,HEIGHT,exp1,LCD_MEM,SPRT_XOR);
		Sprite8(player.x+8,player.y,HEIGHT,exp2,LCD_MEM,SPRT_XOR);
		delay(2000);
		Sprite8(player.x+8,player.y,HEIGHT,exp2,LCD_MEM,SPRT_XOR);
		Sprite8(player.x+8,player.y,HEIGHT,exp3,LCD_MEM,SPRT_XOR);
		delay(2000);
		Sprite8(player.x+8,player.y,HEIGHT,exp3,LCD_MEM,SPRT_XOR);
		Sprite8(player.x+8,player.y,HEIGHT,exp4,LCD_MEM,SPRT_XOR);
		delay(2000);
		Sprite8(player.x+8,player.y,HEIGHT,exp4,LCD_MEM,SPRT_XOR);
		Sprite8(player.x+8,player.y,HEIGHT,exp5,LCD_MEM,SPRT_XOR);
		delay(2000);
		Sprite8(player.x+8,player.y,HEIGHT,exp5,LCD_MEM,SPRT_XOR);
		Sprite8(player.x+8,player.y,HEIGHT,exp6,LCD_MEM,SPRT_XOR);
		delay(2000);
		Sprite8(player.x+8,player.y,HEIGHT,exp6,LCD_MEM,SPRT_XOR);
		for (x=player.x+8;x<=player.x+16;x++) {
			for (y=player.y;y<=player.y+8;y++) {
				if ((x>=notPlayer.x&&x<=notPlayer.x+8) && (y>=notPlayer.y&&y<=notPlayer.y+8)) treffer=1;
			}
		}
	} else 
	if (direction==up) {
		Sprite8(player.x,player.y-8,HEIGHT,exp1,LCD_MEM,SPRT_XOR);
		delay(2000);
		Sprite8(player.x,player.y-8,HEIGHT,exp1,LCD_MEM,SPRT_XOR);
		Sprite8(player.x,player.y-8,HEIGHT,exp2,LCD_MEM,SPRT_XOR);
		delay(2000);
		Sprite8(player.x,player.y-8,HEIGHT,exp2,LCD_MEM,SPRT_XOR);
		Sprite8(player.x,player.y-8,HEIGHT,exp3,LCD_MEM,SPRT_XOR);
		delay(2000);
		Sprite8(player.x,player.y-8,HEIGHT,exp3,LCD_MEM,SPRT_XOR);
		Sprite8(player.x,player.y-8,HEIGHT,exp4,LCD_MEM,SPRT_XOR);
		delay(2000);
		Sprite8(player.x,player.y-8,HEIGHT,exp4,LCD_MEM,SPRT_XOR);
		Sprite8(player.x,player.y-8,HEIGHT,exp5,LCD_MEM,SPRT_XOR);
		delay(2000);
		Sprite8(player.x,player.y-8,HEIGHT,exp5,LCD_MEM,SPRT_XOR);
		Sprite8(player.x,player.y-8,HEIGHT,exp6,LCD_MEM,SPRT_XOR);
		delay(2000);
		Sprite8(player.x,player.y-8,HEIGHT,exp6,LCD_MEM,SPRT_XOR);
		for (y=player.y-8;y<=player.y;y++) {
			for (x=player.x;x<=player.x+8;x++) {
				if ((x>=notPlayer.x&&x<=notPlayer.x+8) && (y>=notPlayer.y&&y<=notPlayer.y+8)) treffer=1;
			}
		}
	} else
	if (direction==down) {
		Sprite8(player.x,player.y+8,HEIGHT,exp1,LCD_MEM,SPRT_XOR);
		delay(2000);
		Sprite8(player.x,player.y+8,HEIGHT,exp1,LCD_MEM,SPRT_XOR);
		Sprite8(player.x,player.y+8,HEIGHT,exp2,LCD_MEM,SPRT_XOR);
		delay(2000);
		Sprite8(player.x,player.y+8,HEIGHT,exp2,LCD_MEM,SPRT_XOR);
		Sprite8(player.x,player.y+8,HEIGHT,exp3,LCD_MEM,SPRT_XOR);
		delay(2000);
		Sprite8(player.x,player.y+8,HEIGHT,exp3,LCD_MEM,SPRT_XOR);
		Sprite8(player.x,player.y+8,HEIGHT,exp4,LCD_MEM,SPRT_XOR);
		delay(2000);
		Sprite8(player.x,player.y+8,HEIGHT,exp4,LCD_MEM,SPRT_XOR);
		Sprite8(player.x,player.y+8,HEIGHT,exp5,LCD_MEM,SPRT_XOR);
		delay(2000);
		Sprite8(player.x,player.y+8,HEIGHT,exp5,LCD_MEM,SPRT_XOR);
		Sprite8(player.x,player.y+8,HEIGHT,exp6,LCD_MEM,SPRT_XOR);
		delay(2000);
		Sprite8(player.x,player.y+8,HEIGHT,exp6,LCD_MEM,SPRT_XOR);
		for (y=player.y+8;y<=player.y+16;y++) {
			for (x=player.x;x<=player.x+8;x++) {
				if ((x>=notPlayer.x&&x<=notPlayer.x+8) && (y>=notPlayer.y&&y<=notPlayer.y+8)) treffer=1;
			}
		}
	}
	
	
	
	
	
	
	return treffer;
}

int b_explode(PLAYER p1,PLAYER enemy) // the round-explosion
{ // I dont think thats the best way to produce an animated big explosion but I cant think of sth better
// the different heights are not there for your annoying! its just to save memory and its quite succesfull
	char treffer=0;
	delay(5000);
	unsigned char left1[] = {
		0b00000011,	0b00001001,	0b00000011,	0b00000001,	0b00000101,
		0b00000011,	0b00001001,	0b00000011,	0b00000001,	0b00000101
	};
	unsigned char left2[] = {
		0b00000001,	0b00001000,	0b00000000,	0b00000100,	0b00010011,	0b00000000,
		0b00001001,	0b01000011,	0b00101001,	0b00000101,	0b00010011,	0b01001001,
		0b00000011,	0b00010001,	0b00000101,	0b00010000,	0b00000100,	0b00001000,
		0b00000001
	};
	unsigned char left3[] = {
		0b00010000,	0b01000101,	0b00001000,	0b00100010,	0b00000100,	0b01000010,
		0b00000000,	0b00001001,	0b01000010,	0b00101001,	0b01000101,	0b00010010,
		0b01001001,	0b00000010,	0b00010001,	0b10000100,	0b00010000,	0b01000100,
		0b00001000,	0b00000001,	0b00010000,	0b00000000,	0b00000100
	};
	unsigned char left4[] = {
		0b00010101,	0b00001000,	0b00100010,	0b00000000,	0b01000000,	0b00000000,
		0b00000000,	0b01000000,	0b00100000,	0b01000000,	0b00010000,	0b01000000,
		0b00000000,	0b00010000,	0b10000000,	0b00010000,	0b01000000,	0b00000000,
		0b00000001,	0b00010000,	0b00000000,	0b00000100
	};
	unsigned char right1[] = {
		0b11000000,	0b10000000,	0b11000000,	0b10000000,	0b10100000,
		0b11000000,	0b10010000,	0b11000000,	0b10000000,	0b10100000
	};
	unsigned char right2[] = {
		0b00001000,	0b01000000,	0b00001000,	0b11000000,	0b10001000,	0b11000000,
		0b10000000,	0b10101010,	0b11000000,	0b10010000,	0b11000100,	0b10000000,
		0b10100000,	0b00000100,	0b00100000,	0b00001000
	};
	unsigned char right3[] = {
		0b01000000,	0b00001000,	0b00100000,	0b00001000,	0b01000001,	0b00001000,
		0b01010000,	0b10001000,	0b01000010,	0b10000000,	0b10101010,	0b01000100,
		0b10010000,	0b01000100,	0b10010001,	0b00100000,	0b10000100,	0b00100000,
		0b00001000,	0b00100000,	0b10010010,	0b00100000
	};
	unsigned char right4[] = {
		0b01000000,	0b00000000,	0b00100000,	0b00000000,	0b00000001,	0b00000000,
		0b00000000,	0b00000000,	0b00000010,	0b00000000,	0b00001010,	0b00000100,
		0b00000000,	0b00000100,	0b00000001,	0b00000000,	0b00000100,	0b00000000,
		0b00000000,	0b00000000,	0b00000010,	0b00100001
	};
	unsigned char top1[] = {
		0b10000000,	0b00001000,
		0b00100010,	0b11111111
	};
	unsigned char top2[] = {
		0b00000010,	0b00100000,	0b00000100,
		0b10010001,	0b00001000,	0b00100010,
		0b11111111
	};
	unsigned char top3[] = {
		0b00100001,	0b10001010,	0b00100000,	0b00000100,
		0b10010001,	0b00001000,	0b00100010,	0b01010101
	};
	unsigned char top4[] = {
		0b00100001,	0b10000010,	0b00000000,
		0b00000100,	0b00010000
	};
	unsigned char bottom1[] = {
		0b11111111,	0b00001010,
		0b01000000,	0b00000100
	};
	unsigned char bottom2[] = {
		0b11111111,	0b00001010,	0b01000000,
		0b00010100,	0b00100000,	0b10000010
	};
	unsigned char bottom3[] = {
		0b10110101,	0b00000010,	0b01000000,	0b00010000,
		0b00000000,	0b10000010,	0b00001000,	0b00100010
	};
	unsigned char bottom4[] = {
		0b10000010,	0b00000000,	0b00100010
	};
	//--------------------------------------------------------------------------------------------------------
	Sprite8(p1.x-8,p1.y-2,10,left1,LCD_MEM,SPRT_XOR);
	Sprite8(p1.x+8,p1.y-2,10,right1,LCD_MEM,SPRT_XOR);
	Sprite8(p1.x,p1.y-4,4,top1,LCD_MEM,SPRT_XOR);
	Sprite8(p1.x,p1.y+8,4,bottom1,LCD_MEM,SPRT_XOR);
	delay(2500);
	Sprite8(p1.x-8,p1.y-2,10,left1,LCD_MEM,SPRT_XOR);
	Sprite8(p1.x+8,p1.y-2,10,right1,LCD_MEM,SPRT_XOR);
	Sprite8(p1.x,p1.y-4,4,top1,LCD_MEM,SPRT_XOR);
	Sprite8(p1.x,p1.y+8,4,bottom1,LCD_MEM,SPRT_XOR);
	//----------------------------------------------
	Sprite8(p1.x-8,p1.y-6,19,left2,LCD_MEM,SPRT_XOR);
	Sprite8(p1.x+8,p1.y-5,16,right2,LCD_MEM,SPRT_XOR);
	Sprite8(p1.x,p1.y-7,7,top2,LCD_MEM,SPRT_XOR);
	Sprite8(p1.x,p1.y+8,6,bottom2,LCD_MEM,SPRT_XOR);
	delay(2500);
	Sprite8(p1.x-8,p1.y-6,19,left2,LCD_MEM,SPRT_XOR);
	Sprite8(p1.x+8,p1.y-5,16,right2,LCD_MEM,SPRT_XOR);
	Sprite8(p1.x,p1.y-7,7,top2,LCD_MEM,SPRT_XOR);
	Sprite8(p1.x,p1.y+8,6,bottom2,LCD_MEM,SPRT_XOR);
	//----------------------------------------------
	Sprite8(p1.x-8,p1.y-7,23,left3,LCD_MEM,SPRT_XOR);
	Sprite8(p1.x+8,p1.y-8,22,right3,LCD_MEM,SPRT_XOR);
	Sprite8(p1.x,p1.y-8,8,top3,LCD_MEM,SPRT_XOR);
	Sprite8(p1.x,p1.y+8,8,bottom3,LCD_MEM,SPRT_XOR);
	delay(2500);
	Sprite8(p1.x-8,p1.y-7,23,left3,LCD_MEM,SPRT_XOR);
	Sprite8(p1.x+8,p1.y-8,22,right3,LCD_MEM,SPRT_XOR);
	Sprite8(p1.x,p1.y-8,8,top3,LCD_MEM,SPRT_XOR);
	Sprite8(p1.x,p1.y+8,8,bottom3,LCD_MEM,SPRT_XOR);
	//----------------------------------------------
	Sprite8(p1.x-8,p1.y-6,22,left4,LCD_MEM,SPRT_XOR);
	Sprite8(p1.x+8,p1.y-8,22,right4,LCD_MEM,SPRT_XOR);
	Sprite8(p1.x,p1.y-8,7,top4,LCD_MEM,SPRT_XOR);
	Sprite8(p1.x,p1.y+13,3,bottom4,LCD_MEM,SPRT_XOR);
	delay(2500);
	Sprite8(p1.x-8,p1.y-6,22,left4,LCD_MEM,SPRT_XOR);
	Sprite8(p1.x+8,p1.y-8,22,right4,LCD_MEM,SPRT_XOR);
	Sprite8(p1.x,p1.y-8,7,top4,LCD_MEM,SPRT_XOR);
	Sprite8(p1.x,p1.y+13,3,bottom4,LCD_MEM,SPRT_XOR);
	unsigned char x,y;
	for (x=p1.x-8;x<=p1.x+8;x++) {
		for (y=p1.y-8;y<=p1.y+16;y++) {
			if ((x>=enemy.x&&x<=enemy.x+8) && (y>=enemy.y&&y<=enemy.y+8)) treffer=1;
		}
	}
	
	return treffer;
}







int explode_row(PLAYER player,PLAYER notPlayer) // obvious - an explosion-row
{
	PLAYER num;
	char treffer=0,direction;
	direction=direct();
	num.x=player.x;		num.y=player.y;
	
	if (direction==left) for (num.x=player.x;num.x>=player.x-16;num.x-=8) {

		if (num.x<8) break;
		if (!treffer) treffer=s_explode(num,notPlayer,direction); else s_explode(num,notPlayer,direction);
	}
	if (direction==right) for (num.x=player.x;num.x<=player.x+16;num.x+=8) {
		if (num.x>LCD_WIDTH-8) break;
		if (!treffer) treffer=s_explode(num,notPlayer,direction); else s_explode(num,notPlayer,direction);
	}
	if (direction==up) for (num.y=player.y;num.y>=player.y-16;num.y-=8) {
		if (num.y<8) break;
		if (!treffer) treffer=s_explode(num,notPlayer,direction); else s_explode(num,notPlayer,direction);
	}
	if (direction==down) for (num.y=player.y;num.y<=player.y+16;num.y+=8) {
		if (num.y>LCD_HEIGHT-16) break;
		if (!treffer) treffer=s_explode(num,notPlayer,direction); else s_explode(num,notPlayer,direction);
	}
	
	
	
	
	
	
	return treffer;
}

int special(PLAYER p1,PLAYER enemy) // list of special-attacks
{
	unsigned char y;
	unsigned char arrow[] = {
		0b00011100,
		0b00000110,
		0b11111111,
		0b11111111,
		0b00000110,
		0b00011100
	};
	clrscr();
	y=21;
	FontSetSys(F_8x10);
	DrawStr(LCD_WIDTH/2-60,0,"Special-Attacks",A_NORMAL);
	FontSetSys(F_4x6);
	DrawStr(0,LCD_HEIGHT-7,"Attack    | mp needed - mp get back  | dmg",A_NORMAL);
	FontSetSys(F_6x8);
	Sprite8(0,y,6,arrow,LCD_MEM,SPRT_XOR);
	DrawStr(10,20,"nothing",A_NORMAL);
	DrawStr(10,30,"s-explosion      |1-2 | 10",A_NORMAL);
	DrawStr(10,40,"row-explosion    |2-1 | 10",A_NORMAL);
	DrawStr(10,50,"energy blast     |3-1 | 30",A_NORMAL);
	DrawStr(10,60,"round-explosion  |2-1 | 20",A_NORMAL);
	
	if (p1.mp<2) {
		DrawStr(10,40,"row-explosion    |2-1 | 10",A_SHADED);
		DrawStr(10,50,"energy blast     |3-1 | 30",A_SHADED);
		DrawStr(10,60,"round-explosion  |2-1 | 20",A_SHADED);
	}
	if (p1.mp<3) {
		DrawStr(10,50,"energy blast     |3-1 | 30",A_SHADED);
	}
	
	
	
	while (!(_rowread(0xFDFF)&0x0002)&&!(_rowread(0xFFBF)&0x0040)) {// while not KEY_ENTER
		if ((_rowread(ARROW_ROW)&0x0020)&&y>30) {	// remember that y is always one more than the full number
			Sprite8(0,y,6,arrow,LCD_MEM,SPRT_XOR);	// but I do like more the full numbers
			y-=10;
			if (y==51&&p1.mp<3) y-=10;
			Sprite8(0,y,6,arrow,LCD_MEM,SPRT_XOR);
		}
		if ((_rowread(ARROW_ROW)&0x0080)&& y<60 ) {
			Sprite8(0,y,6,arrow,LCD_MEM,SPRT_XOR);
			y+=10;
			if (y>40&&p1.mp<2) y-=10;
			if (y==51&&p1.mp<3) y+=10;
			Sprite8(0,y,6,arrow,LCD_MEM,SPRT_XOR);
		}
		if (_rowread(0xFEFF)&0x0040) return 10;
		
		delay(2000);
	}
	
	show(p1,enemy);
	
	if (y==31) return 1;
	if (y==41) return 2;
	if (y==51) return 3;
	if (y==61) return 4;
	
	return 0;
}

int energy(PLAYER p1,PLAYER enemy) // energyblast attack
{
	unsigned char num_x,num_y,num,treffer=0,direction;
	
	direction=direct();
	
	if (direction==left) {
	for (num_x=p1.x-1;num_x>=16;num_x--) {
		DrawLine(num_x,p1.y,num_x,p1.y+7,A_XOR);
		for (num=p1.y;num<=p1.y+7;num++) 
			if ((num_x>=enemy.x&&num_x<=enemy.x+8) && (num>=enemy.y&&num<=enemy.y+8)) treffer=1;
		
		if (treffer) break;
		delay(200);
	}
	num=num_x;
	for (num=p1.x-1;num>=num_x;num--) {
		DrawLine(num,p1.y,num,p1.y+7,A_XOR);
		delay(100);
	}
	}
	//-----------------------------------------
	if (direction==right) {
	for (num_x=p1.x+9;num_x<LCD_WIDTH-16;num_x++) {
		DrawLine(num_x,p1.y,num_x,p1.y+7,A_XOR);
		for (num=p1.y;num<=p1.y+7;num++) 
			if (((num_x>=enemy.x&&num_x<=enemy.x+8) && (num>=enemy.y&&num<=enemy.y+8))) treffer=1;
		if (treffer) break;
		delay(200);
	}
	num=num_x;
	for (num=p1.x+9;num<=num_x;num++) {
		DrawLine(num,p1.y,num,p1.y+7,A_XOR);
		delay(100);
	}
	}
	//-----------------------------------------
	if (direction==up) {
	for (num_y=p1.y-1;num_y>8;num_y--) {
		DrawLine(p1.x,num_y,p1.x+7,num_y,A_XOR);
		for (num=p1.x;num<=p1.x+7;num++)
			if ((num_y>=enemy.y&&num_y<=enemy.y+8) && (num>=enemy.x&&num<=enemy.x+8)) treffer=1;
			if (treffer) break;
			delay(200);
	}
	num=num_y;
	for (num=p1.y-1;num>=num_y;num--) {
		DrawLine(p1.x,num,p1.x+7,num,A_XOR);
		delay(100);
	}
	}
	//-----------------------------------------
	if (direction==down) {
	for (num_y=p1.y+9;num_y<LCD_HEIGHT-9;num_y++) {
		DrawLine(p1.x,num_y,p1.x+7,num_y,A_XOR);
		for (num=p1.x;num<=p1.x+7;num++)
			if ((num_y>=enemy.y&&num_y<=enemy.y+8) && (num>=enemy.x&&num<=enemy.x+8)) treffer=1;
			if (treffer) break;
			delay(200);
	}
	num=num_y;
	for (num=p1.y+9;num<=num_y;num++) {
		DrawLine(p1.x,num,p1.x+7,num,A_XOR);
		delay(100);
	}
	}
	
	
	
	
	
	
	
	return treffer;
	
}

int gattack(PLAYER enemy,PLAYER p1) // should the enemy attack? And which direction?
{
	unsigned char x,y,hit=0;
	
	
	
	// its best to find out if it would be clever to attack...
	for (x=enemy.x-8;x<=enemy.x+8;x++) {
		for (y=enemy.y-8;y<=enemy.y+8;y++) {
			if ((x>=p1.x&&x<=p1.x+8)&&(y>=p1.y&&y<=p1.y+8)) {hit=1;	break;}
		}
		if (hit) break;
	}
	//-----------------------
	if (hit&&random(7)==1) { // if it is clever to attack: do it!
	// I included the random-number because it wouldnt be good if the enemy attacked all the time
		
		return richtung(enemy,p1); // we can use this function because it tests the best direction
		// and why should I write the same twice?
	}// if (hit)
	
	
	return 0;
	
	
}


void start(PLAYER p1,PLAYER enemy) // game intro
{
	int key;
	unsigned short arPfeil[]={0x0180,0x03c0,0x07e0,0x0180,0x0180,0x2184,0x6186,0xffff,
														0xffff,0x6186,0x2184,0x0180,0x0180,0x07e0,0x03c0,0x0180};
	unsigned char explosion[]={0x21,0x4a,0x3c,0x7e,0x3c,0x52,0x84,0x00};
	clrscr();
	FontSetSys(F_8x10);
	DrawStr(LCD_WIDTH/2-28,0,"Fighter",A_NORMAL);
	Sprite8(LCD_WIDTH/2-28,13,HEIGHT,player,LCD_MEM,SPRT_OR);
	Sprite8(LCD_WIDTH/2+20,13,HEIGHT,gegner,LCD_MEM,SPRT_OR);
	Sprite8(LCD_WIDTH/2-40,1,HEIGHT,explosion,LCD_MEM,SPRT_OR);
	Sprite8(LCD_WIDTH/2+32,1,HEIGHT,explosion,LCD_MEM,SPRT_OR);
	FontSetSys(F_6x8);
	Sprite16(LCD_WIDTH/2-8,LCD_HEIGHT/2-8,16,arPfeil,LCD_MEM,SPRT_OR);
	DrawStr(LCD_WIDTH/2-12,LCD_HEIGHT/2-22,"play",A_NORMAL);
	DrawStr(LCD_WIDTH/2-13,LCD_HEIGHT/2+15,"keys",A_NORMAL);
	DrawStr(LCD_WIDTH/2-70,LCD_HEIGHT/2-4,"the game",A_NORMAL);
	DrawStr(LCD_WIDTH/2+17,LCD_HEIGHT/2-4,"special-attacks",A_NORMAL);
	FontSetSys(F_4x6);
	DrawStr(0,LCD_HEIGHT-10,"by Andreas Schoenfeld",A_NORMAL);
	FontSetSys(F_6x8);
	// Tasten-Druck fr Start-Bildschirm
	key=ngetchx();
	while (key!=KEY_LEFT&&key!=KEY_RIGHT&&key!=KEY_UP&&key!=KEY_DOWN&&key!=KEY_ESC) key=ngetchx();
	if (key==KEY_ESC) return;
	if (key==KEY_LEFT) {
		clrscr();
		FontSetSys(F_6x8);
		printf("the objective of this game is to kill 
as much enemys as you can.
Both of you have 100 health in the
beginning. you can not heal yourself.
If you lose all your health the game
will be over. If your enemy loses all
his health a new will come and you get a point.

You begin with 3 mp. If you have no
more mp it will automaticly raise to 1.
Your attacks need different amounts of mp and they give back different amounts
of mp when hitting your enemy.");
		ngetchx();
		start(p1,enemy);
	}
	 if (key==KEY_RIGHT) {
	 	special(p1,enemy); clrscr();
	 	start(p1,enemy);
	 }
	if (key==KEY_DOWN) {
		clrscr();
		printf("Arrow-keys: move\n
Esc:        quit\n
Hand:       small explosion\n
Apps:       special attack");
	ngetchx();
	start(p1,enemy);
	}
}







void _main(void)	{
	PLAYER p1,enemy;
	int pt=-1;
	char Direct,oldDirect=0;		// to make the enemy-moves a bit randomly
	INT_HANDLER interrupt1 = GetIntVec(AUTO_INT_1); // save auto-interrupt 1
	INT_HANDLER interrupt5 = GetIntVec(AUTO_INT_5); // save auto-interrupt 5
	
	p1.health=100;
	p1.x=20;	p1.y=15;	p1.mp=30;
	randomize();
	start(p1,enemy);
	p1.mp=3;
	SetIntVec(AUTO_INT_1,DUMMY_HANDLER);
	SetIntVec(AUTO_INT_5,DUMMY_HANDLER);
	
	while (p1.health!=0) {
		pt++;
		if (pt) b_explode(enemy,p1);
		enemy.health=100;
		enemy.x=LCD_WIDTH/2;	enemy.y=LCD_HEIGHT/2;
		show(p1,enemy);
		state(p1,pt,enemy);
		
		while (enemy.health!=0) {
			if (_rowread(0xFF7F)&0x0040) {
				switch (special(p1,enemy)) {
					case 1: // s-explosion      |1-2  10
						p1.mp-=1;
						if (s_explode(p1,enemy,0)) {
							enemy.health-=10;
							p1.mp+=2;
							if (p1.mp>99) p1.mp=99;
						}
//						state(p1,pt,enemy);
						break;
					case 2:// row-explosion    |2-1  10
						p1.mp-=2;
						if (explode_row(p1,enemy)) {
							enemy.health-=10;
							p1.mp+=1;
						}
//						state(p1,pt,enemy);
						break;
					case 3:// energy blast     |3-1  30
						p1.mp-=3;
						if (energy(p1,enemy)) {
							if (enemy.health-30<0) enemy.health=0; else enemy.health-=30;
							p1.mp+=1;
						}
						
//						state(p1,pt,enemy);
						break;
					case 4:// round-explosion  |2-1  20
						p1.mp-=2;
						if (b_explode(p1,enemy)) {
							if (enemy.health-20<0) enemy.health=0; else enemy.health-=20;
							p1.mp+=1;
						}
//						state(p1,pt,enemy);
						break;
					case 10:
						SetIntVec(AUTO_INT_1,interrupt1);	//	reset the interrupts
						SetIntVec(AUTO_INT_5,interrupt5);
						
						break;
				}
				if (p1.mp>99) p1.mp=99;
				if (p1.mp==0) p1.mp=1;
				state(p1,pt,enemy);
				
			}// special
			
			if (_rowread(0xFEFF)&0x0040) {	// KEY_ESC
				SetIntVec(AUTO_INT_1,interrupt1);	//	reset the interrupts
				SetIntVec(AUTO_INT_5,interrupt5);
				return;
			}
			
			if (_rowread(ARROW_ROW)&0x0008) { // KEY_HAND
				p1.mp-=1;
				if (s_explode(p1,enemy,0)) {
					enemy.health-=10;
					p1.mp+=2;
					if (p1.mp>99) p1.mp=99;
				}
				state(p1,pt,enemy);
			}
			
			if (_rowread(ARROW_ROW)&0x0010) {			// KEY_LEFT
				if (test(p1,left)) {
					Sprite8(p1.x,p1.y,HEIGHT,player,LCD_MEM,SPRT_XOR);
					p1.x--;
					Sprite8(p1.x,p1.y,HEIGHT,player,LCD_MEM,SPRT_XOR);
				}
			}
			if (_rowread(ARROW_ROW)&0x0040) {			// KEY_RIGHT
				if (test(p1,right)) {
					Sprite8(p1.x,p1.y,HEIGHT,player,LCD_MEM,SPRT_XOR);
					p1.x++;
					Sprite8(p1.x,p1.y,HEIGHT,player,LCD_MEM,SPRT_XOR);
				}
			}
			if (_rowread(ARROW_ROW)&0x0020) {			// KEY_UP
				if (test(p1,up)) {
					Sprite8(p1.x,p1.y,HEIGHT,player,LCD_MEM,SPRT_XOR);
					p1.y--;
					Sprite8(p1.x,p1.y,HEIGHT,player,LCD_MEM,SPRT_XOR);
				}
			}
			if (_rowread(ARROW_ROW)&0x0080) {			// KEY_DOWN
				if (test(p1,down)) {
					Sprite8(p1.x,p1.y,HEIGHT,player,LCD_MEM,SPRT_XOR);
					p1.y++;
					Sprite8(p1.x,p1.y,HEIGHT,player,LCD_MEM,SPRT_XOR);
				}
			}
//-----------------------------------------------------------------------------------------------------------
			// enemys move
			Direct=richtung(enemy,p1);
			// it wouldnt be best to let the enemy always move straight on to the player! so...
			if (random(2)==1) Direct=random(5)+1;
			if (Direct!=oldDirect&&random(2)==1) Direct=oldDirect;
			
			if (gattack(enemy,p1)) Direct=5;
			
			if (Direct==left) {	// move left
				if (test(enemy,left)) {
					Sprite8(enemy.x,enemy.y,HEIGHT,gegner,LCD_MEM,SPRT_XOR);
					enemy.x--;
					Sprite8(enemy.x,enemy.y,HEIGHT,gegner,LCD_MEM,SPRT_XOR);
					oldDirect=Direct;
				}
			}
			if (Direct==right) {	// move right
				if (test(enemy,right)) {
					Sprite8(enemy.x,enemy.y,HEIGHT,gegner,LCD_MEM,SPRT_XOR);
					enemy.x++;
					Sprite8(enemy.x,enemy.y,HEIGHT,gegner,LCD_MEM,SPRT_XOR);
					oldDirect=Direct;
				}
			}
			if (Direct==up) {	// move up
				if (test(enemy,up)) {
					Sprite8(enemy.x,enemy.y,HEIGHT,gegner,LCD_MEM,SPRT_XOR);
					enemy.y--;
					Sprite8(enemy.x,enemy.y,HEIGHT,gegner,LCD_MEM,SPRT_XOR);
					oldDirect=Direct;
				}
			}
			if (Direct==down) {	// move down
				if (test(enemy,down)) {
					Sprite8(enemy.x,enemy.y,HEIGHT,gegner,LCD_MEM,SPRT_XOR);
					enemy.y++;
					Sprite8(enemy.x,enemy.y,HEIGHT,gegner,LCD_MEM,SPRT_XOR);
					oldDirect=Direct;
				}
			}
			if (Direct==5) {// the enemy-attack
				Direct=gattack(enemy,p1);
				if (Direct && s_explode(enemy,p1,Direct)) {
					p1.health-=10;
					state(p1,pt,enemy);
				}
				
			}// enemy-attack
			
			
			
			
			
			
			delay(800);	//	slow down the program
		}	//while enemy-player lives	===========================================================================
		
		
		
		
	} // while human-player lives 	===========================================================================
	
	
	
	
	
	
	
	
	
	
	SetIntVec(AUTO_INT_1,interrupt1);	//	reset the interrupts
	SetIntVec(AUTO_INT_5,interrupt5);
}
